#include <bits/stdc++.h>

//#define ll long long
#define int long long

using namespace std;

const int MAXN = 1e5 + 10;


vector<pair<int, int>> graph[MAXN];
pair<int, int> dp[MAXN][2];

int k;

void dfs(int v) {
    vector<pair<int, int>> diffs;
    pair<int, int> res;
    for (auto[u, w]: graph[v]) {
        dfs(u);
        auto new_it = dp[u][1];
        new_it.first++;
        new_it.second += -w;
        pair<int, int> diff = {dp[u][0].first - new_it.first, dp[u][0].second - new_it.second};
        res.first += dp[u][0].first, res.second += dp[u][0].second;
        diffs.push_back(diff);
    }
    sort(diffs.begin(), diffs.end());
    for (int i = 0; i < min((int) diffs.size(), k); ++i) {
        if (i == k - 1)
            dp[v][1] = res;
        res.first -= diffs[i].first, res.second -= diffs[i].second;
    }
    if (graph[v].size() < k) dp[v][1] = res;
    dp[v][0] = res;
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n >> k;
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        graph[p].emplace_back(i, w);
    }
    dfs(0);
    auto ans = max(dp[0][0], dp[0][1]);
    cout << ans.first << " " << -ans.second << endl;
    return 0;
}