#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

//#define ll long long
#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int MAXK = 100;
const int INF = 1e15 + 7;
const int L = 20;


int a[MAXN];
int pref[MAXN];
int lgt[MAXN];
int rgt[MAXN];
int up_mx[MAXN][L];
int up_mn[MAXN][L];
int lg[MAXN];


int get_mn(int l, int r) {
    if (r == l) return 0;
    int len = r - l;
    int lh = lg[len];
    return min(up_mn[r - 1][lh], up_mn[l + (1 << lh) - 1][lh]);
}

int get_mx(int l, int r) {
    if (r == l) return 0;
    int len = r - l;
    int lh = lg[len];
    return max(up_mx[r - 1][lh], up_mx[l + (1 << lh) - 1][lh]);
}

int get_sum(int l, int r) {
    return pref[r] - pref[l];
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (k == 0) {
        int mx = -INF;
        vector<int> dp(n + 1);
        for (int i = 0; i < n; ++i) {
            dp[i + 1] = max(dp[i], 0ll) + a[i];
            mx = max(mx, dp[i + 1]);
        }
        cout << mx;
        exit(0);
    }
    if (k == 1) {
        lg[1] = 0;
        for (int i = 2; i <= n; ++i)
            lg[i] = lg[i / 2] + 1;
        for (int i = 0; i < n; ++i)
            pref[i + 1] = pref[i] + a[i];
        vector<int> st;
        for (int i = 0; i < n; ++i) {
            while (!st.empty() && a[st.back()] <= a[i])
                st.pop_back();
            if (st.empty())
                lgt[i] = -1;
            else
                lgt[i] = st.back();
            st.push_back(i);
        }
        st.clear();
        for (int i = n - 1; i >= 0; --i) {
            while (!st.empty() && a[st.back()] <= a[i])
                st.pop_back();
            if (st.empty())
                rgt[i] = n;
            else
                rgt[i] = st.back();
            st.push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            for (int l = 0; l < L; ++l) {
                up_mx[i][l] = -INF;
                up_mn[i][l] = INF;
            }
        }
        for (int i = 0; i < n; ++i) {
            up_mx[i][0] = pref[i + 1];
            up_mn[i][0] = pref[i + 1];
            for (int l = 1; l < L; ++l) {
                up_mx[i][l] = max(up_mx[i][l - 1], up_mx[max(0ll, i - (1 << (l - 1)))][l - 1]);
                up_mn[i][l] = min(up_mn[i][l - 1], up_mn[max(0ll, i - (1 << (l - 1)))][l - 1]);
            }
        }
        int mx = -INF;
        for (int i = 0; i < n; ++i) {
//            cout << min(get_mn(max(0ll, lgt[i]), i + 1), lgt[i] == -1 ? 0 : INF) << "\n";
            mx = max(mx, pref[i] - min(get_mn(max(0ll, lgt[i]), i), lgt[i] == -1 ? 0 : INF) + get_mx(i, rgt[i]) -
                         pref[i + 1]);
        }
        cout << mx << "\n";
        exit(0);
    }
    int mx = 0;
    for (int l = 0; l < n; ++l) {
        multiset<int> best;
        int sum = 0;
        int sum_banned = 0;
        for (int r = l; r < n; ++r) {
            best.insert(a[r]);
            sum_banned += a[r];
            if (best.size() > k) {
                int mn = *best.begin();
                best.erase(best.begin());
                sum += mn;
            }
            mx = max(mx, sum);
        }
    }
    cout << mx;
    return 0;
}