#include <bits/stdc++.h>

#define ll long long
#define int long long

using namespace std;


const int MAXN = 1e7 + 1;
const int INF = 1e9 + 1e7 + 7;

int d[2 * MAXN];
int st1[MAXN], st2[MAXN];
int mn1[MAXN], mn2[MAXN];
int l1, l2;
const ll MOD = 1e9;

void add(int x) {
    st1[l1] = x;
    mn1[l1] = min(l1 == 0 ? INF : mn1[l1 - 1], x);
    ++l1;
}

void pop() {
    if (l2 == 0) {
        while (l1 != 0) {
            st2[l2] = st1[l1 - 1];
            mn2[l2] = min(l2 == 0 ? INF : mn2[l2 - 1], st1[l1 - 1]);
            l1--;
            l2++;
        }
    }
    l2--;
}

int mn() {
    int ans = INF;
    if (l1 != 0) ans = min(ans, mn1[l1 - 1]);
    if (l2 != 0) ans = min(ans, mn2[l2 - 1]);
    return ans;
}


signed main() {
    int n;
    cin >> n;
    int f;
    cin >> f;
    if (f == 1) {
        for (int i = 0; i < n; ++i) {
            cin >> d[i];
            d[i + n] = d[i];
        }
    } else {
        int m;
        cin >> m;
        ll x, y, z;
        cin >> x >> y >> z;
        for (int i = 0; i < n; ++i) {
            if (i < m) {
                cin >> d[i];
            } else {
                d[i] = ((x * ((ll) d[i - 2]) + y * ((ll) d[i - 1]) + z) % MOD) + 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        add(i - d[i]);
    }
    int best = INF;
    int ind = -1;
    for (int i = 0; i < n; ++i) {
        int need = max(0ll, i - mn());
        if (best > need) {
            best = need;
            ind = i;
        }
        pop();
        add((i + n) - d[i + n]);
    }
    cout << best << " " << ind + 1 << "\n";
    return 0;
}
