#include <bits/stdc++.h>

//#define ll long long
#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int INF = 1e15 + 7;


vector<pair<int, int>> graph[MAXN];
pair<int, int> dp[MAXN][2];

int k;

void dfs(int v) {
    vector<pair<int, int>> diffs;
    pair<int, int> res = {0, 0};
    for (auto[u, w]: graph[v]) {
        dfs(u);
        auto new_it = dp[u][1];
        new_it.first++;
        new_it.second -= w;
        auto it = max(dp[u][0], dp[u][1]);
        pair<int, int> diff = {it.first - new_it.first, it.second - new_it.second};
        res.first += it.first, res.second += it.second;
        diffs.push_back(diff);
    }
//    auto comp = [&](pair<int, int> lhs, pair<int, int> rhs) -> bool {
//        int lcost = -lhs.second, rcost = -rhs.second;
//        return tie(lhs.first, lcost) < tie(rhs.first, rcost);
//    };
    dp[v][0] = dp[v][1] = {0, -INF};
    sort(diffs.begin(), diffs.end());
    for (int i = 0; i < min((int) diffs.size(), k); ++i) {
        if (i <= k - 1)
            dp[v][1] = max(dp[v][1], res);
        res.first -= diffs[i].first, res.second -= diffs[i].second;
    }
    if (graph[v].size() < k) dp[v][1] = max(dp[v][0], res);
    dp[v][0] = max(res, dp[v][1]);
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n >> k;
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        graph[p].emplace_back(i, w);
    }
    dfs(0);
    pair<int, int> t_ans = {0, -INF};
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> cnt(n);
        pair<int, int> ans = {0, 0};
        for (int i = 0; i < n; ++i) {
            for (auto[j, w]: graph[i]) {
                if ((mask >> j) & 1) {
                    cnt[i]++;
                    cnt[j]++;
                    ans.first++;
                    ans.second -= w;
                }
            }
        }
        
        for(int i = 0; i < n; ++i) {
            if(cnt[i] > k) ans = {0, -INF};
        }

        t_ans = max(t_ans, ans);
    }
    auto ans = max(dp[0][0], dp[0][1]);
    cout << t_ans.first << " " << -t_ans.second << endl;
    return 0;
}