#include <bits/stdc++.h>

//#define ll long long
#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int MAXK = 100;
const int INF = 1e15 + 7;

int a[MAXN];
int pref[MAXN];

int get_sum(int l, int r) {
    return pref[r] - pref[l];
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (k == 0) {
        int mx = -INF;
        vector<int> dp(n + 1);
        for (int i = 0; i < n; ++i) {
            dp[i + 1] = max(dp[i], 0ll) + a[i];
            mx = max(mx, dp[i + 1]);
        }
        cout << mx;
        exit(0);
    }
    int best = -INF;
    for (int mn_i = 0; mn_i < n; ++mn_i) {
        vector<int> new_a(n);
        vector<int> mn_len(n);
        queue<int> zeros;
        for (int i = 0; i < n; ++i) {
            if (a[i] > a[mn_i] || (a[i] == a[mn_i] && i <= mn_i)) {
                new_a[i] = 0;
                zeros.push(i);
                if (zeros.size() > k) zeros.pop();
            } else {
                new_a[i] = a[i];
            }
            if (zeros.size() < k)
                mn_len[i] = -1;
            else
                mn_len[i] = zeros.front();
            pref[i + 1] = pref[i] + new_a[i];
        }
        vector<int> dp(n + 1);
        for (int i = 0; i < n; ++i) {
            dp[i + 1] = max(dp[i], 0ll) + new_a[i];
        }
        for (int i = 0; i < n; ++i) {
            if (mn_len[i] != -1) best = max(best, dp[mn_len[i]] + get_sum(mn_len[i], i + 1));
        }
    }
    cout << best;
    return 0;
}